diff --git a/test/unit/operatingsystem_test.rb b/test/unit/operatingsystem_test.rb
index b09450f..d486f29 100644
--- a/test/unit/operatingsystem_test.rb
+++ b/test/unit/operatingsystem_test.rb
@@ -1,6 +1,9 @@
 require 'test_helper'
 
 class OperatingsystemTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
   test "shouldn't save with blank attributes" do
     operating_system = Operatingsystem.new
     assert !operating_system.save
@@ -76,4 +79,65 @@ class OperatingsystemTest < ActiveSupport::TestCase
     operating_system = Operatingsystem.new :name => "Ubuntu", :major => "9", :minor => "10"
     assert operating_system.to_s == operating_system.to_label
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_operatingsystems"
+      role.permissions = ["#{operation}_operatingsystems".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Operatingsystem.create :name => "dummy", :major => 7
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Operatingsystem.create :name => "dummy", :major => 7
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Operatingsystem.first
+    as_admin do
+      record.hosts = []
+    end
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Operatingsystem.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Operatingsystem.first
+    record.name = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Operatingsystem.first
+    record.name = "renamed"
+    as_admin do
+      record.hosts = []
+    end
+    assert !record.save
+    assert record.valid?
+  end
+
 end
diff --git a/test/unit/parameter_test.rb b/test/unit/parameter_test.rb
index 0985773..89c0b92 100644
--- a/test/unit/parameter_test.rb
+++ b/test/unit/parameter_test.rb
@@ -1,4 +1,7 @@
 class ParameterTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
   test  "names may me reused in different parameter groups" do
     p1 = HostParameter.new   :name => "param", :value => "value1", :reference_id => Host.first
     assert p1.save
diff --git a/test/unit/ptable_test.rb b/test/unit/ptable_test.rb
index 1de4867..e5c1b07 100644
--- a/test/unit/ptable_test.rb
+++ b/test/unit/ptable_test.rb
@@ -1,6 +1,10 @@
 require 'test_helper'
 
 class PtableTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
+
   test "name can't be blank" do
     partition_table = Ptable.new :name => "   ", :layout => "any layout"
     assert partition_table.name.strip.empty?
@@ -62,4 +66,65 @@ class PtableTest < ActiveSupport::TestCase
 
     assert !partition_table.destroy
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_ptables"
+      role.permissions = ["#{operation}_ptables".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Ptable.create :name => "dummy", :layout => "layout"
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Ptable.create :name => "dummy", :layout => "layout"
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Ptable.first
+    as_admin do
+      record.hosts = []
+    end
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Ptable.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Ptable.first
+    record.name = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Ptable.first
+    record.name = "renamed"
+    as_admin do
+      record.hosts = []
+    end
+    assert !record.save
+    assert record.valid?
+  end
+
 end
diff --git a/test/unit/puppetclass_test.rb b/test/unit/puppetclass_test.rb
index 304452e..0330e4f 100644
--- a/test/unit/puppetclass_test.rb
+++ b/test/unit/puppetclass_test.rb
@@ -1,6 +1,10 @@
 require 'test_helper'
 
 class PuppetclassTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
+
   test "name can't be blank" do
     puppet_class = Puppetclass.new
     assert !puppet_class.save
@@ -36,4 +40,65 @@ class PuppetclassTest < ActiveSupport::TestCase
     assert klasses[1] == "other_puppet_class"
     assert klasses[2] == "yet_another_puppet_class"
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_puppetclasses"
+      role.permissions = ["#{operation}_puppetclasses".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Puppetclass.create :name => "dummy"
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Puppetclass.create :name => "dummy"
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Puppetclass.first
+    as_admin do
+      record.hosts = []
+    end
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Puppetclass.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Puppetclass.first
+    record.name = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Puppetclass.first
+    record.name = "renamed"
+    as_admin do
+      record.hosts = []
+    end
+    assert !record.save
+    assert record.valid?
+  end
+
 end
diff --git a/test/unit/report_observer_test.rb b/test/unit/report_observer_test.rb
index 5b939d9..358e8f3 100644
--- a/test/unit/report_observer_test.rb
+++ b/test/unit/report_observer_test.rb
@@ -2,6 +2,8 @@ require 'test_helper'
 
 class ReportObserverTest < ActiveSupport::TestCase
   def setup
+    User.current = User.find_by_login "admin"
+
     # Email recepient
     SETTINGS[:administrator] = "admin@example.com"
 
diff --git a/test/unit/report_test.rb b/test/unit/report_test.rb
index 909cec1..e6dee80 100644
--- a/test/unit/report_test.rb
+++ b/test/unit/report_test.rb
@@ -2,6 +2,7 @@ require 'test_helper'
 
 class ReportTest < ActiveSupport::TestCase
   def setup
+    User.current = User.find_by_login "admin"
     @r=Report.import File.read(File.expand_path(File.dirname(__FILE__) + "/../fixtures/report-skipped.yaml"))
   end
 
@@ -71,4 +72,47 @@ class ReportTest < ActiveSupport::TestCase
     @r.save
     assert Report.with("skipped").include?(@r)
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_reports"
+      role.permissions = ["#{operation}_reports".to_sym]
+      @one.roles = [role]
+      @one.save!
+      @r.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record = @r
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  @r
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to edit" do
+    # Reports are not an editable resource
+    setup_user "edit"
+    record        =  @r
+    record.status = {}
+    assert !record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record        =  @r
+    record.status = {}
+    assert !record.save
+    assert record.valid?
+  end
+
 end
diff --git a/test/unit/role_test.rb b/test/unit/role_test.rb
new file mode 100644
index 0000000..ab5b56d
--- /dev/null
+++ b/test/unit/role_test.rb
@@ -0,0 +1,104 @@
+# redMine - project management software
+# Copyright (C) 2006-2008  Jean-Philippe Lang
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+require File.dirname(__FILE__) + '/../test_helper'
+
+class RoleTest < ActiveSupport::TestCase
+  fixtures :roles
+
+    should have_many :user_roles
+    should have_many(:users).through(:user_roles)
+
+    should validate_presence_of :name
+    should validate_uniqueness_of :name
+    should ensure_length_of(:name).is_at_most(30)
+    should allow_value("a role name").for(:name)
+    should_not allow_value(";a role name").for(:name)
+    should_not allow_value(" a role name").for(:name)
+    should_not allow_value("a role name ").for(:name)
+
+  def test_add_permission
+    role = Role.find(1)
+    size = role.permissions.size
+    role.add_permission!("apermission", "anotherpermission")
+    role.reload
+    assert role.permissions.include?(:anotherpermission)
+    assert_equal size + 2, role.permissions.size
+  end
+
+  def test_remove_permission
+    role = Role.find(1)
+    size = role.permissions.size
+    perm = role.permissions[0..1]
+    role.remove_permission!(*perm)
+    role.reload
+    assert ! role.permissions.include?(perm[0])
+    assert_equal size - 2, role.permissions.size
+  end
+
+  context "System roles" do
+    should "return the anonymous role" do
+      role = Role.anonymous
+      assert role.builtin?
+      assert_equal Role::BUILTIN_ANONYMOUS, role.builtin
+    end
+
+    context "with a missing anonymous role" do
+      setup do
+        Role.delete_all("builtin = #{Role::BUILTIN_ANONYMOUS}")
+      end
+
+      should "create a new anonymous role" do
+        assert_difference('Role.count') do
+          Role.anonymous
+        end
+      end
+
+      should "return the anonymous role" do
+        role = Role.anonymous
+        assert role.builtin?
+        assert_equal Role::BUILTIN_ANONYMOUS, role.builtin
+      end
+    end
+  end
+
+  context "Default_user" do
+    should "return the default_user role" do
+      role = Role.default_user
+      assert role.builtin?
+      assert_equal Role::BUILTIN_DEFAULT_USER, role.builtin
+    end
+
+    context "with a missing default_user role" do
+      setup do
+        Role.delete_all("builtin = #{Role::BUILTIN_DEFAULT_USER}")
+      end
+
+      should "create a new default_user role" do
+        assert_difference('Role.count') do
+          Role.default_user
+        end
+      end
+
+      should "return the default_user role" do
+        role = Role.default_user
+        assert role.builtin?
+        assert_equal Role::BUILTIN_DEFAULT_USER, role.builtin
+      end
+    end
+  end
+end
diff --git a/test/unit/subnet_test.rb b/test/unit/subnet_test.rb
index 53cf287..0d5fb0c 100644
--- a/test/unit/subnet_test.rb
+++ b/test/unit/subnet_test.rb
@@ -2,6 +2,7 @@ require 'test_helper'
 
 class SubnetTest < ActiveSupport::TestCase
   def setup
+    User.current = User.find_by_login "admin"
     @subnet = Subnet.new
     @attrs = {  :number= => "123.123.123.1",
                 :mask= => "321.321.321.3",
@@ -97,5 +98,66 @@ class SubnetTest < ActiveSupport::TestCase
     @subnet.domain_id = @domain.id
     @subnet.save
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_subnets"
+      role.permissions = ["#{operation}_subnets".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Subnet.create :name => "dummy", :number => "1.2.3.4", :mask => "255.255.255.0"
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Subnet.create :name => "dummy", :number => "1.2.3.4", :mask => "255.255.255.0"
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Subnet.first
+    as_admin do
+      record.domain = nil
+    end
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Subnet.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Subnet.first
+    record.name = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Subnet.first
+    record.name = "renamed"
+    as_admin do
+      record.domain = nil
+    end
+    assert !record.save
+    assert record.valid?
+  end
+
 end
 
diff --git a/test/unit/user_fact_test.rb b/test/unit/user_fact_test.rb
new file mode 100644
index 0000000..4dfb122
--- /dev/null
+++ b/test/unit/user_fact_test.rb
@@ -0,0 +1,8 @@
+require 'test_helper'
+
+class UserFactTest < ActiveSupport::TestCase
+  # Replace this with your real tests.
+  test "the truth" do
+    assert true
+  end
+end
diff --git a/test/unit/user_test.rb b/test/unit/user_test.rb
index 919f42e..55d2bd2 100644
--- a/test/unit/user_test.rb
+++ b/test/unit/user_test.rb
@@ -2,6 +2,7 @@ require 'test_helper'
 
 class UserTest < ActiveSupport::TestCase
   def setup
+    User.current = User.find_by_login "admin"
     @user = User.create :auth_source => auth_sources(:one), :login => "foo", :mail  => "foo@bar.com"
   end
 
@@ -86,5 +87,64 @@ class UserTest < ActiveSupport::TestCase
   test  "should not be able to delete the admin account" do
     assert !User.find_by_login("admin").destroy
   end
+  
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_users"
+      role.permissions = ["#{operation}_users".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  User.new :login => "dummy", :mail => "j@j.com", :auth_source_id => AuthSourceInternal.first.id
+    record.password_hash = "asd"
+    assert record.save
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  User.new :login => "dummy", :mail => "j@j.com", :auth_source_id => AuthSourceInternal.first.id
+    record.password_hash = "asd"
+    assert !record.save
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  users(:one)
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  User.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  User.first
+    record.login = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  User.first
+    record.login = "renamed"
+    assert !record.save
+    assert record.valid?
+  end
+
 end
 
diff --git a/test/unit/usergroup_test.rb b/test/unit/usergroup_test.rb
index e611afe..f7ad5a0 100644
--- a/test/unit/usergroup_test.rb
+++ b/test/unit/usergroup_test.rb
@@ -1,7 +1,9 @@
 require 'test_helper'
 
 class UsergroupTest < ActiveSupport::TestCase
-
+  setup do
+    User.current = User.find_by_login("admin")
+  end
   test "usergroups should be creatable" do
     assert Usergroup.create(:name => "name").valid?
   end
@@ -98,4 +100,59 @@ class UsergroupTest < ActiveSupport::TestCase
       ug1.destroy
     end
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_usergroups"
+      role.permissions = ["#{operation}_usergroups".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Usergroup.create :name => "dummy"
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Usergroup.create :name => "dummy"
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Usergroup.first
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Usergroup.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Usergroup.first
+    record.name = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Usergroup.first
+    record.name = "renamed"
+    assert !record.save
+    assert record.valid?
+  end
+
 end
